您的位置:首页 > 其它

hdu 4336 Card Collector 概率dp+状态压缩

2014-09-30 12:38 495 查看


Card Collector

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 2594 Accepted Submission(s): 1209

Special Judge


Problem Description

In your childhood, do you crazy for collecting the beautiful cards in the snacks? They said that, for example, if you collect all the 108 people in the famous novel Water Margin, you will win an amazing award.

As a smart boy, you notice that to win the award, you must buy much more snacks than it seems to be. To convince your friends not to waste money any more, you should find the expected number of snacks one should buy to collect a full suit of cards.

Input

The first line of each test case contains one integer N (1 <= N <= 20), indicating the number of different cards you need the collect. The second line contains N numbers p1, p2, ..., pN, (p1 + p2 + ... + pN <= 1), indicating the possibility of each card to
appear in a bag of snacks.

Note there is at most one card in a bag of snacks. And it is possible that there is nothing in the bag.

Output

Output one number for each test case, indicating the expected number of bags to buy to collect all the N different cards.

You will get accepted if the difference between your answer and the standard answer is no more that 10^-4.

Sample Input

1
0.1
2
0.1 0.4


Sample Output

10.000
10.500


Source

2012 Multi-University Training Contest 4

Recommend

zhoujiaqi2010 | We have carefully selected several similar problems for you: 4337 4331 4332 4333 4334

题意:就是小时候吃方便面攒卡片,问攒满所有卡片要吃多少包。

思路:因为每种卡片的概率都不同,所以都要分情况考虑,好在这题卡片数量在20以内,可以用状态压缩做。

直接1维数组表示状态为i时的期望,那么dp[(1<<n)-1]表示拥有所有卡片时的期望,自然是0.

状态方程:dp[i]=sp*dp[i]+ Σ(dp[j]*p[k])+1 //其中sp表示抽到重复卡片或没抽到卡片,j表示状态i-第k个卡片的状态

化简得 dp[i]=(Σ(dp[j]*p[k])+1)/(1-sp)

然后就是求了

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <map>
using namespace std;
const int N=20;
const int inf=0x3f3f3f3f;
double dp[1<<N],p
;
int n;
int main()
{
while(scanf("%d",&n)!=EOF){
double s=1;
for(int i=0;i<n;i++){
scanf("%lf",&p[i]);
s-=p[i];
}
memset(dp,0,sizeof(dp));
for(int i=(1<<n)-2;i>=0;i--){
double sp=s;
for(int j=0;j<n;j++){
int q=1<<j;
if(i&q)sp+=p[j];
else dp[i]+=dp[i|q]*p[j];
}
dp[i]++;
dp[i]/=1-sp;
}
printf("%lf\n",dp[0]);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: